import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Arrays;


//I'm a computer science sophemore and this class create a book collection stored in an array of books of length size and makes many methods to manipulate this collection.
public class BookCollection {
	private Book[] books;
	private int size;
	
	public BookCollection(int size) {
		//Constructor that creates the array of books with length size.
		this.size=size;
		this.books = new Book[size];
	}
	
	public void setBook(Book book, int i) {
		books[i]=book;
	}
	
	public void add(Book book) {
		//adds a book to the array of the books.
		books = Arrays.copyOf(books, size+1);
		books[size-1]=book;
	}
	
	public void remove(Book book) {
		//remove a book from the books array if it exists.
		boolean use = false;
		int index=0;
		for(int i=0; i<size; i++) {
			if(books[i]==book){
				use=true;
				index = i;
			}
		}
		if(use){
			Book[] inUse = new Book[size-1];
			for(int i=0; i<index; i++) {
				inUse[i]=books[i];
			}
			for(int i=index; i<inUse.length; i++){
				inUse[i]=books[i+1];
			}
			books=inUse;
		}
	}
	
	public void sortByTitle() {
		//sort the books array by title.
		Book[] use = new Book[size];
		Book compare=books[0];
		Book min=books[0];
		for(int i=0; i<size; i++){
			for(int j=0; j<size; j++){
				compare=books[j];
				for(int k=0; k<size; k++) {
					if(compare.compareToByTitle(books[k])==1){
						min=books[k];
					} else if(compare.compareToByTitle(books[k])==-1){
						min=compare;
					}
				}
			}
			use[i]=min;
			this.remove(min);
		}
		books=use;
	}
	
	public void sortByAuthorName() {
		//sort the array of books by author name.
		Book[] use = new Book[size];
		Book compare=books[0];
		Book min=books[0];
		for(int i=0; i<size; i++){
			for(int j=0; j<size; j++){
				compare=books[j];
				for(int k=0; k<size; k++) {
					if(compare.compareToByAuthor(books[k])==1){
						min=books[k];
					} else if(compare.compareToByAuthor(books[k])==-1){
						min=compare;
					}
				}
			}
			use[i]=min;
			this.remove(min);
		}
		books=use;
	}
	
	public void printToFile(String fileName) throws FileNotFoundException {
		//takes a filename and prints the books from the books array in this file.
		PrintStream output = new PrintStream(new File(fileName));
		
		for(int i=0; i<size; i++){
			output.println(books[i].toString());
		}
	}
}
