
//I'm a computer science sophomore and this program is a new class for Complex numbers filled with methods to operate on them.
public class Complex {
	private double re;
	private double im;
	public static void main(String[] args) {
		//testing the methods created.
		Complex c = new Complex (5.6, -3.7);
		
		System.out.println(c.toString());
		
		System.out.printf("the real part of c is: &f and the imaginary part is %f", c.getRe(), c.getIm());
		
		Complex z = new Complex (-2, 8.9);
		System.out.println("\nIf we add z to c we get the new complex: " + c.add(z) + "\nAnd if we substract z from c we get: " + c.sub(z));
		
		Complex f = new Complex (6, 1);
		System.out.println("if we multiple f by z we get: " + f.prod(z) + "\nAnd if we devide f by c we get: " + f.div(c));
		
		Complex a =  new Complex(2.98, -14.96);
		System.out.println("The norm and conjugate of a are respectively: " + a.norm() + ", " + a.conj() + "\nAnd if we raise a to the power 3 we get: " + a.pow(3));
		
	}
	
	public Complex (double re, double im) {
		//constructor;
		this.re=re;
		this.im=im;
	}
	
	public double getRe(){
		//gets the real part of the complex object.
		return re;
	}
	
	public double getIm(){
		//gets the imaginary part of the complex object.
		return im;
	}
	
	public Complex add(Complex z) {
		//adds this complex object with the complex parameter.
		double real = this.re+z.getRe();
		double imaginary = this.im+z.getIm();
		Complex c = new Complex(real, imaginary);
		return c;
	}
	
	public Complex sub(Complex z) {
		//Subtract from this complex object the complex parameter.
		double real = this.re-z.getRe();
		double imaginary = this.im-z.getIm();
		Complex c = new Complex(real, imaginary);
		return c;
	}
	
	public Complex prod(Complex z) {
		//multiply this complex object with the complex parameter.
		double real=this.re*z.getRe()-this.im*z.getIm();
		double imaginary=this.im*z.getRe()+this.re*z.getIm();
		Complex c = new Complex(real, imaginary);
		return c;
	}
	
	public Complex conj() {
		//returns the conjugate of the complex object.
		double imaginary=-this.im;
		Complex c = new Complex(this.re, imaginary);
		return c;
	}
	
	public double norm() {
		//returns the norm of the complex object.
		return Math.sqrt(re*re+im*im);
	}
	
	public Complex div (Complex z) {
		//divide the complex object by the parameter complex.
		Complex denominator = z.prod(z.conj());
		Complex numerator = this.prod(z.conj());
		double deno = denominator.getRe();
	Complex c = new Complex(numerator.getRe()/deno, numerator.getIm()/deno);
	return c;
	}
	
	public Complex pow(double p) {
		//raise the complex object to the power in the parameter, p.
		double theta = Math.acos(this.re/this.norm());
		double real = Math.pow(this.norm(),p)*Math.cos(p*theta);
		double imaginary = Math.pow(this.norm(),p)*Math.sin(p*theta);
		Complex c = new Complex(real, imaginary);
		return c;
	}
	
	public String toString() {
		//returns a string representation of the complex object.
		if(this.getIm()>0){
			return (this.getRe() +" + " + this.getIm()+ "i");
		}else {
			return (this.getRe() +" " + this.getIm()+ "i");
		}
		
	}
}
