import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;


//I'm a computer science sophomore and this program reads a file full with integers, prints the original 2D array representation of the integers then prints a transposed version of it.
public class Transpose {
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner cmd = new Scanner (System.in);
		System.out.printf("Enter the name of the 2D file: ");
		int[][] toTranspose = readArray(cmd.next());
		int[][] transposed = transpose(toTranspose);
		
		System.out.println("The original 2D array: ");
		printArray(toTranspose);
		
		System.out.println("The transposed 2D array: ");
		printArray(transposed);
	}
	public static int[][] readArray(String fileName) throws FileNotFoundException {
		//reads a file and return a 2D array containing the integers in it.
		Scanner scan = new Scanner(new File(fileName));
		int rows = scan.nextInt();
		int columns = scan.nextInt();
		int[][] toReturn= new int[rows][columns];
		
		for(int i=0; i<rows; i++){
			//fill the rows.
			for(int j=0;j<columns; j++){
				//fill the columns in each row.
				toReturn[i][j]=scan.nextInt();
			}
		}
		return toReturn;
	}
	public static void printArray(int[][] a){
		//prints the array in a neat way.
		for(int i=0; i<a.length; i++){
			//checks each row.
			for(int j=0; j<a[0].length;j++){
				//prints each integer on each row separated with white spaces.
				System.out.printf("%-5d ", a[i][j]);
			}
			System.out.println();
		}
	}
	public static int[][] transpose(int[][]a) {
		//reverse rows and columns of the 2D array and returns a copy of it
		int[][] toReturn = new int [a[0].length][a.length];
		for(int i=0; i<toReturn.length;i++){
			//fill rows of the new array.
			for (int j=0; j<toReturn[0].length; j++){
				//fill the columns of the new array.
				toReturn[i][j]=a[j][i];
			}
		}
		return toReturn;
		
	}
	
}
